/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*- */
/* Copyright (C) 2001 The Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * Authors: Ante Brkic <abrkic@linux.hr>
 * Contributions:
 *          Arturo Espinosa <arturo@ximian.com> (team codes and minor bugs).
 *          Dario Lah <dlah@foi.hr>
 *          Vlatko Kosturjak <kost@iname.com>
 *          Robert Avilov <ravilov@linux.hr>
 */

#include "si3d.h"

void
uvodni_izbor (void)
{
  int r=0, t, i;
  long int br;
/* (dialog proc) (x) (y) (w) (h) (fg) (bg) (key) (flags) (d1) 
                 (d2) (dp) (dp2) (dp3) */
  DIALOG main_menu[] = {
    {d_button, 70, 180, 160, 20, 0, 0, 0, 0, 0, 0,
		 "NEW GAME", NULL, NULL},
    {d_button, 70, 220, 160, 20, 0, 0, 0, 0, 0, 0,
		 "LOAD GAME", NULL, NULL},
    {d_button, 70, 260, 160, 20, 0, 0, 0, 0, 0, 0, 
		 "OPTIONS", NULL, NULL},
    {d_button, 70, 300, 160, 20, 0, 0, 0, 0, 0, 0, 
		 "CREDITS", NULL, NULL},
    {d_button, 70, 360, 160, 20, 0, 0, 0, 0, 0, 0, 
		 "EXIT", NULL, NULL},
    {NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		 NULL, NULL, NULL}
  };

  DIALOG new_menu[] = {
    {d_button, 70, 300, 100, 20, 0, 0, 0, 0, 0, 0,
		 "GENERATE", NULL, NULL},
    {d_button, 70, 360, 100, 20, 0, 0, 0, 0, 0, 0,
		 "BACK", NULL, NULL},
    {d_screenshot, 70, 180, 100, 20, 0, 0, 0, 0, 0, 0, 
		 "GRASS", "SSHOT1", NULL},
    {d_screenshot, 70, 200, 100, 20, 0, 0, 0, 0, 1, 0,
		 "ICE", "SSHOT2", NULL},
    {d_screenshot, 70, 220, 100, 20, 0, 0, 0, 0, 1, 0,
		 "SAND", "SSHOT3", NULL},
    {d_screenshot, 70, 240, 100, 20, 0, 0, 0, 0, 1, 0,
		 "MOUNTINES", "SSHOT4", NULL},
    {d_screenshot, 70, 260, 100, 20, 0, 0, 0, 0, 1, 0,
		 "VULCANO", "SSHOT5", NULL},
    {NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		 NULL, NULL, NULL}
  };

  DIALOG options_menu[] = {
    {d_option, 70, 180, 160, 20, 0, 0, 0, 0, 1, 0,
		 "TEAMS", NULL, NULL},
    {d_option, 70, 220, 160, 20, 0, 0, 0, 0, 2, 0,
		 "PLAYERS/TEAM", NULL, NULL},
    {d_option, 70, 260, 160, 20, 0, 0, 0, 0, 3, 0,
		 "ROUNDS", NULL, NULL},
    {d_option, 70, 300, 360, 20, 0, 0, 0, 0, 4, 0,
		 "WIND STRENGTH", NULL, NULL},
    {d_option, 70, 340, 160, 20, 0, 0, 0, 0, 5, 0,
		 "WIND CHANGE", NULL, NULL},
    {d_button, 70, 400, 160, 20, 0, 0, 0, 0, 0, 0,
		 "BACK", NULL, NULL},
    {NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		 NULL, NULL, NULL}
  };

  DIALOG credits_menu[] = {
    {d_credits, 70, 180, 569, 280, 0, 0, 0, 0, 255, 255, NULL, NULL, NULL},
    {d_button, 70, 460, 160, 40, 0, 0, 0, 0, 255, 255, "BACK", NULL, NULL},
    {NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
		 NULL, NULL, NULL}
  };

  pocetne_vrijednosti ();

	blit(background[0].dat, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	blit(background[0].dat, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

  do {
    blit(background[0].dat, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		switch ( do_dialog(main_menu, 0)) {
		case 0:
			switch (t = do_dialog(new_menu, 2)) {
			case 0:
				napravi_kartu(); /* generate */
				r = -1;
				break;
			case 1:
				r = 0;
				break;
			default:
	      ucitaj_kartu (t-1);
				r = -1;
	      break;
	    }
			for (i=0;i<7; i++)
				new_menu[i].d2 = 2;
			new_menu[2].d2 = 3;
			break;
		case 1:
			r = 0;
			break;
		case 2:
			t = 0;
			do {
		    blit(background[0].dat, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
				switch (t = do_dialog(options_menu, t)) {
					case 0:
							broj_teams++;
							if (broj_teams > 4)
								broj_teams = 2;
							broj_igraca = broj_teams * broj_team_size;
							break;
					case 1:
							broj_team_size++;
							if (broj_team_size > 33)
								broj_team_size = 1;
							broj_igraca = broj_teams * broj_team_size;
							break;
					case 2:
							max_broj_rundi += 2;
							if (max_broj_rundi > 7)
								max_broj_rundi = 1;
							break;
					case 3:
							jacina_vjetra++;
							if (jacina_vjetra > 3)
								jacina_vjetra = 0;
							break;
					case 4:
							promjena_vjetra++;
							if (promjena_vjetra > 1)
								promjena_vjetra = 0;
							break;
					case 5:
						r = 0;
						break;
					}
			} while (t != 5);
			break;
		case 3:
	    blit(background[0].dat, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
			r = do_dialog(credits_menu, 1);
			r = 0;
			break;
		case 4:
			destroy_bitmap(suc);
			destroy_bitmap(slika_suc);
			destroy_bitmap(pogled);
			destroy_bitmap(small_health);
			destroy_bitmap(big_health);
			destroy_bitmap(ap);
			destroy_bitmap(mp);
			destroy_bitmap(shield);
			destroy_bitmap(weapon);
			destroy_bitmap(za_monitor);
			exit (0);
		} /*switch*/
	}	while (r == 0);
  ispisi_sucelje (1);
  crtaj_sucelje (1);
  for (br = 0; br < broj_igraca; br++)
	{
		boja_fonta = makecol (20, 120, 20);
		textprintf (aktivni, font, tenk[br].x - 15,
								120 - tenk[br].z + tenk[br].y / 2, boja_fonta, "%i",
								(int) tenk[br].energija);
		if (igrac == br)
		{
			circle (aktivni,tenk[br].x, 150 - tenk[br].z + tenk[br].y / 2, 30,
							makecol (100, 100, 100));
		}
	}
  broj_runde = 1;
  boja_fonta = makecol (255, 255, 255);
  textprintf (aktivni, font, 290, 230,boja_fonta, "ROUND 1");
	sleep (1);
  aktivni = za_monitor;
  crtaj_tenk (igrac);
  blit (aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}

void
ispisi_sucelje (int map)
{
  int br, br1, r, g, b, boja;
  int startx = 0, dod;
  int w, h;

  if (map == 1)
	{
		aktivni = slika_suc;
        
		for (h = 0; h < 640; h++)
			for (w = 0; w < 640; w++)
			{
				boja = reljef[w][h].vis + 55;
				if (boja < 0)
					boja = 0;
				putpixel(aktivni,576 + w * 0.079, 5 + h * 0.077,makecol(boja,boja,boja));
            
			}
/*		for (br=0; br<broj_igraca; br++)
			if (br!=igrac)
			{
			gl_setpixel(576+tenk[br].x*0.079, 5+tenk[br].y*0.077, gl_rgbcolor(tenk[br].r, tenk[br].g, tenk[br].b));
			gl_setpixel(577+tenk[br].x*0.079, 6+tenk[br].y*0.077, gl_rgbcolor(tenk[br].r, tenk[br].g, tenk[br].b));
			gl_setpixel(577+tenk[br].x*0.079, 5+tenk[br].y*0.077, gl_rgbcolor(tenk[br].r, tenk[br].g, tenk[br].b));
			gl_setpixel(576+tenk[br].x*0.079, 6+tenk[br].y*0.077, gl_rgbcolor(tenk[br].r, tenk[br].g, tenk[br].b));
			}*/
	}
  aktivni = slika_suc;
  blit(aktivni, suc, 0,0,0,0,SCREEN_W,60);
  aktivni = suc;
  
  boja_fonta = makecol(tenk[igrac].r, tenk[igrac].g, tenk[igrac].b);
  textprintf (aktivni, font, 20, 10, boja_fonta, "%s",tenk[igrac].ime );
  boja_fonta = makecol(20,140,20);
  textprintf (aktivni, font, 23, 40, boja_fonta, "%02i", (int) (90 - 180 * tenk[igrac].kut_cijevi / PI));
  textprintf (aktivni, font, 61, 40, boja_fonta, "%03i", (int) (180 * tenk[igrac].kut / PI));
  if (tenk[igrac].ap > 0)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].ap == 0)
    boja_fonta=makecol(20,90,20);    
	textprintf (aktivni, font, 231, 14, boja_fonta, "%02i", tenk[igrac].ap);
  if (tenk[igrac].mp > 1)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].mp <= 1)
    boja_fonta=makecol(20,90,20);
  textprintf (aktivni, font, 231, 38, boja_fonta, "%02.0f", floor(tenk[igrac].mp));

  for (br = 198; br > 198 - (100 - tenk[igrac].energija) * 0.73; br--)
    line(aktivni,br, 13, br, 20,makecol(5,5,5));
  for (br = 198; br > 198 - (100 - tenk[igrac].stit) * 0.73; br--)
    line(aktivni,br, 37, br, 44,makecol(5,5,5));

  boja_fonta = makecol(20,170,20);
  textprintf (aktivni, font, 292, 34,boja_fonta, "+");
  textprintf (aktivni, font, 309, 34,boja_fonta, "+");
  if (tenk[igrac].w[2] > 0)
		boja_fonta = makecol(20,170,20);
	if (tenk[igrac].w[2] == 0)
		boja_fonta = makecol(20,90,20);
	textprintf (aktivni, font, 326, 34,boja_fonta, "%i", tenk[igrac].w[2]);
  if (tenk[igrac].w[3] > 0)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].w[3] == 0)
    boja_fonta = makecol(20,90,20);
  textprintf (aktivni, font, 342, 34,boja_fonta, "%i", tenk[igrac].w[3]);
  if (tenk[igrac].w[4] > 0)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].w[4] == 0)
    boja_fonta = makecol(20,90,20);
  textprintf (aktivni, font, 358, 34,boja_fonta, "%i", tenk[igrac].w[4]);
  if (tenk[igrac].w[5] > 0)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].w[5] == 0)
    boja_fonta = makecol(20,90,20);
	textprintf (aktivni, font, 374, 34,boja_fonta, "%i", tenk[igrac].w[5]);
  if (tenk[igrac].w[6] > 0)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].w[6] == 0)
    boja_fonta = makecol(20,90,20);
	textprintf (aktivni, font, 391, 34,boja_fonta, "%i", tenk[igrac].w[6]);
  if (tenk[igrac].w[7] > 0)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].w[7] == 0)
    boja_fonta = makecol(20,90,20);
	textprintf (aktivni, font, 407, 34,boja_fonta, "%i", tenk[igrac].w[7]);
  if (tenk[igrac].w[8] > 0)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].w[8] == 0)
    boja_fonta = makecol(20,90,20);
  textprintf (aktivni, font, 423, 34,boja_fonta, "%i", tenk[igrac].w[8]);
  if (tenk[igrac].w[9] > 0)
    boja_fonta = makecol(20,170,20);
  if (tenk[igrac].w[9] == 0)
    boja_fonta = makecol(20,90,20);
  textprintf (aktivni, font, 439, 34,boja_fonta, "%i", tenk[igrac].w[9]);
  if (tenk[igrac].w[10] > 0)
    boja_fonta=makecol(20,170,20);
  if (tenk[igrac].w[10] == 0)
    boja_fonta = makecol(20,90,20);
  textprintf (aktivni, font, 456, 34,boja_fonta, "%i", tenk[igrac].w[10]);

  dod = 0;
  if (tenk[igrac].aktivno_oruzje == 0)
    startx = 291;
  if (tenk[igrac].aktivno_oruzje == 1)
    startx = 307;
  if (tenk[igrac].aktivno_oruzje == 1)
    dod = 1;
  if (tenk[igrac].aktivno_oruzje == 2)
    startx = 324;
  if (tenk[igrac].aktivno_oruzje == 3)
    startx = 340;
  if (tenk[igrac].aktivno_oruzje == 4)
    startx = 356;
  if (tenk[igrac].aktivno_oruzje == 5)
    startx = 372;
  if (tenk[igrac].aktivno_oruzje == 5)
    dod = 1;
  if (tenk[igrac].aktivno_oruzje == 6)
    startx = 389;
  if (tenk[igrac].aktivno_oruzje == 7)
    startx = 405;
  if (tenk[igrac].aktivno_oruzje == 8)
    startx = 421;
  if (tenk[igrac].aktivno_oruzje == 9)
    startx = 437;
  if (tenk[igrac].aktivno_oruzje == 9)
    dod = 1;
  if (tenk[igrac].aktivno_oruzje == 10)
    startx = 454;

  for (br = startx; br < startx + 11 + dod; br++)
    for (br1 = 32; br1 < 42; br1++)
		{
			r = getr(getpixel(aktivni,br,br1));
			g = getg(getpixel(aktivni,br,br1));
			b = getb(getpixel(aktivni,br,br1));
			r += 20;
			g += 80;
			b += 20;
			if (r > 255)
				r = 255;
			if (g > 255)
				g = 255;
			if (b > 255)
				b = 255;
			putpixel(aktivni,br,br1,makecol(r,g,b));
		}

  x_pomak_vjetra = cos (kut_vjetra) * jacina_vjetra;
  y_pomak_vjetra = sin (kut_vjetra) * jacina_vjetra;
  line(aktivni, 526, 29, 526 + (int) (x_pomak_vjetra * 8),
       29 - (int) (y_pomak_vjetra * 8), makecol(170,170,170));


  for (br = 0; br < broj_igraca; br++)
	{
		putpixel(aktivni,576 + tenk[br].x * 0.079, 5 + tenk[br].y * 0.077,
						 makecol(tenk[br].r, tenk[br].g, tenk[br].b));
		putpixel(aktivni,577 + tenk[br].x * 0.079, 6 + tenk[br].y * 0.077,
						 makecol(tenk[br].r, tenk[br].g, tenk[br].b));
     
		putpixel(aktivni,577 + tenk[br].x * 0.079, 5 + tenk[br].y * 0.077,
						 makecol(tenk[br].r, tenk[br].g, tenk[br].b));

		putpixel(aktivni,577 + tenk[br].x * 0.079, 6 + tenk[br].y * 0.077,
						 makecol(tenk[br].r, tenk[br].g, tenk[br].b));

	}

  for (br = 0; br < broj_poklona; br++)
	{
		if (poklon[br].vrsta == 1 || poklon[br].vrsta == 2)
		{
			putpixel(aktivni,576 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(255,255,255));
			putpixel(aktivni,577 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(200,25,25));
			putpixel(aktivni,575 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(200,25,25));
			putpixel(aktivni,577 + poklon[br].x * 0.079, 4 + poklon[br].y * 0.077, makecol(200,25,25));
			putpixel(aktivni,576 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(200,25,25));
		}
		if (poklon[br].vrsta == 3)
		{
			putpixel(aktivni,576 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(255,255,255));          
			putpixel(aktivni,576 + poklon[br].x * 0.079, 4 + poklon[br].y * 0.077, makecol(255,255,255));
			putpixel(aktivni,576 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(20,25,255));
			putpixel(aktivni,575 + poklon[br].x * 0.079, 4 + poklon[br].y * 0.077, makecol(20,25,255));
			putpixel(aktivni,575 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(20,25,255));            
			putpixel(aktivni,577 + poklon[br].x * 0.079, 4 + poklon[br].y * 0.077, makecol(20,25,255));         
			putpixel(aktivni,577 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(20,25,255));        
		}
		if (poklon[br].vrsta == 4)
		{
			putpixel(aktivni,576 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(255,155,155));
			putpixel(aktivni,577 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(200,25,25));
			putpixel(aktivni,576 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(255,155,155));
			putpixel(aktivni,577 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(200,25,25)); 
		}
		if (poklon[br].vrsta == 5)
		{
			putpixel(aktivni,576 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(155,255,155));
			putpixel(aktivni,577 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(25,200,25));
			putpixel(aktivni,576 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(155,255,155));
			putpixel(aktivni,577 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(25,200,25)); 
		}
		if (poklon[br].vrsta == 6)
		{
			putpixel(aktivni,575 + poklon[br].x * 0.079, 4 + poklon[br].y * 0.077, makecol(100,100,0));  
			putpixel(aktivni,576 + poklon[br].x * 0.079, 4 + poklon[br].y * 0.077, makecol(200,200,0));  
			putpixel(aktivni,577 + poklon[br].x * 0.079, 4 + poklon[br].y * 0.077, makecol(100,100,0));  
			putpixel(aktivni,575 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(200,200,0));  
			putpixel(aktivni,576 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(255,255,255));  
			putpixel(aktivni,576 + poklon[br].x * 0.079, 5 + poklon[br].y * 0.077, makecol(200,200,0));  
			putpixel(aktivni,575 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(100,100,0));  
			putpixel(aktivni,576 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(200,200,0));  
			putpixel(aktivni,577 + poklon[br].x * 0.079, 6 + poklon[br].y * 0.077, makecol(100,100,0));  
		}
	}
}

void
crtaj_sucelje (int mod)
{
  int br, br1, br2;
  double pom;

  aktivni = za_monitor;
  
  if (mod == 1)
	{
		aktivni = pogled;
        
		blit(aktivni, za_monitor,0, 0, 0, 0, SCREEN_W, SCREEN_H);
		aktivni = za_monitor;
        
		crtaj_tenk (igrac);
		pom = 50;
		for (br = 600; br > 0; br -= pom)
		{
			if (pom > 0.5)
				pom -= 2;
			blit(suc,aktivni,0, br / 10,0,0,640, 60 - br / 10);
          
			blit(aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		}
	}
  if (mod == -1)
	{
		pom = 50;
		for (br = 0; br < 600; br += pom)
		{
			aktivni = pogled;
            
			blit(aktivni, za_monitor,0, 0, 0, 0, SCREEN_W, SCREEN_H);
			aktivni = za_monitor;
            
			crtaj_tenk (igrac);
			blit(suc,aktivni,0, br / 10,0,0,640, 60 - br / 10);
			blit(aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
			for (br1 = 0; br1 < 1000; br1++)
				for (br2 = 0; br2 < 5; br2++);
			if (pom < 50)
				pom += 2;
		}
		aktivni = pogled;
      
		blit(aktivni, za_monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		aktivni = za_monitor;
      
		crtaj_tenk (igrac);
		blit(aktivni, monitor, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	}
  if (mod == 0)
		blit(suc,aktivni,0, 0,0,0,640, 60);
}
